Codeforces Round #305 (Div.2) D

来源:互联网 发布:mac艺术字体下载大全 编辑:程序博客网 时间:2024/05/29 09:35

B. Mike and Feet
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mike is the president of country What-The-Fatherland. There are n bears living in this country besides Mike. All of them are standing in a line and they are numbered from 1 to n from left to right. i-th bear is exactly ai feet high.

A group of bears is a non-empty contiguous segment of the line. The size of a group is the number of bears in that group. The strength of a group is the minimum height of the bear in that group.

Mike is a curious to know for each x such that 1 ≤ x ≤ n the maximum strength among all groups of size x.

Input

The first line of input contains integer n (1 ≤ n ≤ 2 × 105), the number of bears.

The second line contains n integers separated by space, a1, a2, ..., an (1 ≤ ai ≤ 109), heights of bears.

Output

Print n integers in one line. For each x from 1 to n, print the maximum strength among all groups of size x.

Sample test(s)
input
101 2 3 4 5 4 3 2 1 6
output
6 4 4 3 3 2 2 1 1 1 


题目大意:

 

有一群小熊站成一排,每只小熊都有一定的身高,定义连续的几只小熊(可以只有1只)称作group。每个group的长度为小熊的数量,强度为该区间最矮的那只熊的身高。

 

现在要你求出长度分别为1n的所有group的最大强度。

 

(题目大意描述的有点不清楚,建议直接看题目)

 

大致思路:

 

一开始看到这道题目以为是线段树,事实上的确有不少人用线段树过了,奈何自己线段树太弱,所以没写出来。直到学习单调栈之后才发现这道题可以用单调栈过,复杂度也只有O(n)。我们枚举每只小熊为最矮身高时向两边扩展能覆盖的最大区间,然后再处理一下就ok了。这里还要注意一点,我们枚举出所有区间之后有可能会有小区间的值反而比大区间的值要小的情况,这个时候就要继承较大区间的值。(也就是说满足区间长度从小到大单调递减)

 

示例代码:

 

//CF_305_D.cpp#include <iostream>#include <algorithm>#include <cstring>#include <cstdlib>#include <cstdio>#include <cmath>#include <queue>#include <map>using namespace std;typedef long long ll;const int maxn = 2*100000 + 10;const int INF = 0x7fffffff;int n;int a[maxn], s[maxn], L[maxn], R[maxn], f[maxn];void solve(){int t = 0;memset(s, 0, sizeof(s));memset(f, 0, sizeof(f));for( int i=0; i<n; ++i ){while( t>0 && a[i]<=a[s[t-1]] ) --t;L[i] = t==0 ? 0 : (s[t-1] + 1);s[t++] = i;}t = 0;for( int i=n-1; i>=0; --i ){while( t>0 && a[i]<=a[s[t-1]] ) --t;R[i] = t==0? n : s[t-1];s[t++] = i;}for( int i=0; i<n; ++i ){f[R[i]-L[i]] = max(a[i], f[R[i]-L[i]]);}for( int i=n-1; i>=0; --i )    {        if( f[i]<f[i+1] )        {            f[i] = f[i+1];        }    }}int main(){while( ~scanf("%d", &n) ){for( int i=0; i<n; ++i ){scanf("%d", &a[i]);}solve();for( int i=1; i<=n-1; ++i ){printf("%d ", f[i]);}printf("%d\n", f[n]);}return 0;}

 

 

 

0 0
原创粉丝点击